#include <fcntl.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdarg.h>
#include <stdint.h>
#include <assert.h>

#include "../casinodev.h"
#include "common.h"

#define SIZE 0x3000


int main()
{
		int fd = do_open0();
		int bfd = do_create_buf(fd, SIZE, NINE_PLUS);
		
		char *buffer = (char *) mmap(0, SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, bfd, 0);

		if (buffer == MAP_FAILED)
			syserr("mmap");

		do_munmap(buffer + 0x2000, 0x1000);
		
		struct casinodev_ioctl_seed_increment seed_increment;
		seed_increment.enable_increment = 1;
		ioctl(fd, CASINODEV_IOCTL_ENABLE_SEED_INCREMENT, &seed_increment);

		uint32_t *cmd = (uint32_t*) (buffer + 0x1000);
		cmd[0] = CASINODEV_USER_CMD_GET_CARDS_HEADER(24, CASINODEV_USER_OUTPUT_FAIR);
		cmd[1] = CASINODEV_USER_CMD_GET_CARDS_HEADER(24, CASINODEV_USER_OUTPUT_FAIR);
		
		do_run(fd, bfd, 0x1000, sizeof(uint32_t) * 2, bfd);
		do_wait(fd, 0);

		seed_increment.enable_increment = 0;
		ioctl(fd, CASINODEV_IOCTL_ENABLE_SEED_INCREMENT, &seed_increment);

		int i;
		struct card * buf_read = (struct card *) buffer;
		for (i = 0; i < 48; ++i)
		{
			assert(buf_read[i].rank >= NINE);
		}
		assert(buf_read[0].rank == JACK);
		assert(buf_read[24].rank == QUEEN);

		do_close(bfd);
		do_munmap(buffer, SIZE - 0x1000);
		do_close(fd);
}
