#include <fcntl.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdarg.h>
#include <stdint.h>
#include <assert.h>

#include "../casinodev.h"
#include "common.h"

#define SIZE 0x3000


int main()
{
		int fd = do_open0();
		int bfd = do_create_buf(fd, SIZE, FULL);
		
		char *buffer = (char *) mmap(0, SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, bfd, 0);

		if (buffer == MAP_FAILED)
			syserr("mmap");

		do_munmap(buffer + 0x2000, 0x1000);
		
		uint32_t *cmd = (uint32_t*) (buffer + 0x1000);
		cmd[0] = CASINODEV_USER_CMD_GET_CARDS_HEADER(12, CASINODEV_USER_OUTPUT_GOOD);
		cmd[1] = CASINODEV_USER_CMD_GET_CARDS_HEADER(12, CASINODEV_USER_OUTPUT_BAD);
		
		do_run(fd, bfd, 0x1000, sizeof(uint32_t) * 2, bfd);
		do_wait(fd, 0);

		struct card * buf_read = (struct card *) buffer;
		assert(buf_read[0].rank == ACE);
		assert(buf_read[3].rank == ACE);
		assert(buf_read[5].rank == KING);
		assert(buf_read[11].rank == QUEEN);
		assert(buf_read[12].rank == TWO);
		assert(buf_read[23].rank == FOUR);

		do_close(bfd);
		do_munmap(buffer, SIZE - 0x1000);
		do_close(fd);
}
