#include <fcntl.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdarg.h>
#include <stdint.h>
#include <assert.h>

#include "../casinodev.h"
#include "common.h"

#define SIZE 0x3000


int main()
{
		int fd = do_open0();
		int bfd = do_create_buf(fd, SIZE, FULL);
		
		char *buffer = (char *) mmap(0, SIZE, PROT_READ | PROT_WRITE, MAP_SHARED, bfd, 0);

		if (buffer == MAP_FAILED)
			syserr("mmap");

		do_munmap(buffer + 0x2000, 0x1000);
		
		uint32_t *cmd = (uint32_t*) (buffer + 0x1000);
		cmd[0] = CASINODEV_USER_CMD_GET_CARDS_HEADER(5, CASINODEV_USER_OUTPUT_FAIR);
		cmd[1] = CASINODEV_USER_CMD_NEW_DECK;
		cmd[2] = CASINODEV_USER_CMD_GET_CARDS_HEADER(5, CASINODEV_USER_OUTPUT_FAIR);
		
		do_run(fd, bfd, 0x1000, sizeof(uint32_t) * 3, bfd);
		do_wait(fd, 0);

		struct card * buf_read = (struct card *) buffer;
		int i;
		for (i = 0; i < 5; ++i)
		{
			assert(buf_read[i].suit == buf_read[i + 5].suit && buf_read[i].rank == buf_read[i + 5].rank);
		}

		do_close(bfd);
		do_munmap(buffer, SIZE - 0x1000);
		do_close(fd);
}
