#include <fcntl.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdarg.h>
#include <stdint.h>
#include <assert.h>
#include "../casinodev.h"

#include "common.h"
#define CMDS 1024

int main() {
	int fd = do_open0();
	int bfd = do_create_buf(fd, CMDS * 5 * 2 * sizeof(struct card), 0);
	int cmdfd = do_create_buf(fd, CMDS * 2 * sizeof(uint32_t), 0);
	
	char *buffer = (char *) mmap(0, CMDS * 2 * sizeof(struct card), PROT_READ | PROT_WRITE, MAP_SHARED, bfd, 0);
	uint32_t *cmd = (uint32_t *) mmap(0, CMDS * 2 * sizeof(uint32_t), PROT_READ | PROT_WRITE, MAP_SHARED, cmdfd, 0);
	if (cmd == MAP_FAILED)
		syserr("mmap");

	for (int i = 0; i < CMDS; i++) {
		cmd[i * 2] = CASINODEV_USER_CMD_GET_CARDS_HEADER(5, CASINODEV_USER_OUTPUT_FAIR);
		cmd[i * 2 +1] = CASINODEV_USER_CMD_GET_CARDS_HEADER(5, CASINODEV_USER_OUTPUT_FAIR);
	}
	do_run(fd, cmdfd, 0, sizeof(uint32_t) * 2 * CMDS, bfd);
	do_wait(fd, 0);
	
	int i;
	struct card * buf_read = (struct card *) buffer;
	for (i = 9; i < CMDS; i += 52)
	{
		assert(buf_read[i].suit == CLUB && buf_read[i].rank == QUEEN);	
	}
	
	do_close(bfd);
	do_close(cmdfd);
	do_munmap(cmd, CMDS * 2 * sizeof(uint32_t));
	do_close(fd);
	return 0;
}